# GstGLBaseSrc

GstGLBaseSrc handles the nitty gritty details of retrieving an OpenGL context. It also provided some wrappers around GstBaseSrc's `start()` and `stop()` virtual methods that ensure an OpenGL context is available and current in the calling thread.

## GstGLBaseSrc

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstBaseSrc
                        ╰──GstPushSrc
                            ╰──GstGLBaseSrc

The parent instance type of a base GStreamer GL Video source.

### Members

`parent` (GstPushSrc) –
No description available
`display` (GstGLDisplay *) –

the currently configured GstGLDisplay

`context` (GstGLContext *) –

the currently configured GstGLContext

`out_info` (GstVideoInfo) –

the currently configured output GstVideoInfo

`out_caps` (GstCaps *) –

the currently configured output GstCaps

`running_time` (GstClockTime) –

the total running time

Since : 1.18

### Class structure

#### GstGLBaseSrcClass

The base class for GStreamer GL Video sources.

##### Fields

`parent_class` (GstPushSrcClass) –
No description available
`supported_gl_api` (GstGLAPI) –

the logical-OR of GstGLAPI's supported by this element

Since : 1.18

### GstGL.GLBaseSrcClass

The base class for GStreamer GL Video sources.

##### Attributes

`parent_class` (GstBase.PushSrcClass) –
No description available
`supported_gl_api` (GstGL.GLAPI) –

the logical-OR of GstGL.GLAPI's supported by this element

Since : 1.18

### GstGL.GLBaseSrcClass

The base class for GStreamer GL Video sources.

##### Attributes

`parent_class` (GstBase.PushSrcClass) –
No description available
`supported_gl_api` (GstGL.GLAPI) –

the logical-OR of GstGL.GLAPI's supported by this element

Since : 1.18

## GstGL.GLBaseSrc

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstBase.BaseSrc
                        ╰──GstBase.PushSrc
                            ╰──GstGL.GLBaseSrc

The parent instance type of a base GStreamer GL Video source.

### Members

`parent` (GstBase.PushSrc) –
No description available
`display` (GstGL.GLDisplay) –

the currently configured GstGL.GLDisplay

`context` (GstGL.GLContext) –

the currently configured GstGL.GLContext

`out_info` (GstVideo.VideoInfo) –

the currently configured output GstVideo.VideoInfo

`out_caps` (Gst.Caps) –

the currently configured output Gst.Caps

`running_time` (Number) –

the total running time

Since : 1.18

## GstGL.GLBaseSrc

    GObject.Object
        ╰──GObject.InitiallyUnowned
            ╰──Gst.Object
                ╰──Gst.Element
                    ╰──GstBase.BaseSrc
                        ╰──GstBase.PushSrc
                            ╰──GstGL.GLBaseSrc

The parent instance type of a base GStreamer GL Video source.

### Members

`parent` (GstBase.PushSrc) –
No description available
`display` (GstGL.GLDisplay) –

the currently configured GstGL.GLDisplay

`context` (GstGL.GLContext) –

the currently configured GstGL.GLContext

`out_info` (GstVideo.VideoInfo) –

the currently configured output GstVideo.VideoInfo

`out_caps` (Gst.Caps) –

the currently configured output Gst.Caps

`running_time` (int) –

the total running time

Since : 1.18

### Methods

#### gst_gl_base_src_get_gl_context

    GstGLContext *
    gst_gl_base_src_get_gl_context (GstGLBaseSrc * base_src)

Parameters:

`base_src` –

a GstGLBaseSrc

Returns ( [nullable][transfer: full]) –

the configured GstGLContext.

Since : 1.28

#### GstGL.GLBaseSrc.prototype.get_gl_context

    function GstGL.GLBaseSrc.prototype.get_gl_context(): {
        // javascript wrapper for 'gst_gl_base_src_get_gl_context'
    }

Parameters:

`base_src` (GstGL.GLBaseSrc) –

a GstGL.GLBaseSrc

Returns (GstGL.GLContext) –

the configured GstGL.GLContext.

Since : 1.28

#### GstGL.GLBaseSrc.get_gl_context

    def GstGL.GLBaseSrc.get_gl_context (self):
        #python wrapper for 'gst_gl_base_src_get_gl_context'

Parameters:

`base_src` (GstGL.GLBaseSrc) –

a GstGL.GLBaseSrc

Returns (GstGL.GLContext) –

the configured GstGL.GLContext.

Since : 1.28

### Properties

#### timestamp-offset

    “timestamp-offset” gint64

Flags : Read / Write

#### timestamp-offset

    “timestamp-offset” Number

Flags : Read / Write

#### timestamp_offset

    “self.props.timestamp_offset” int

Flags : Read / Write

### Virtual Methods

#### fill_gl_memory

    gboolean
    fill_gl_memory (GstGLBaseSrc * src,
                    GstGLMemory * mem)

called in the GL thread to fill the current video texture.

Parameters:

`src` –
No description available
`mem` –
No description available
Returns –
No description available

#### vfunc_fill_gl_memory

    function vfunc_fill_gl_memory(src: GstGL.GLBaseSrc, mem: GstGL.GLMemory): {
        // javascript implementation of the 'fill_gl_memory' virtual method
    }

called in the GL thread to fill the current video texture.

Parameters:

`src` (GstGL.GLBaseSrc) –
No description available
`mem` (GstGL.GLMemory) –
No description available
Returns (Number) –
No description available

#### do_fill_gl_memory

    def do_fill_gl_memory (src, mem):
        #python implementation of the 'fill_gl_memory' virtual method

called in the GL thread to fill the current video texture.

Parameters:

`src` (GstGL.GLBaseSrc) –
No description available
`mem` (GstGL.GLMemory) –
No description available
Returns (bool) –
No description available

#### gl_start

    gboolean
    gl_start (GstGLBaseSrc * src)

called in the GL thread to setup the element GL state.

Parameters:

`src` –
No description available
Returns –
No description available

#### vfunc_gl_start

    function vfunc_gl_start(src: GstGL.GLBaseSrc): {
        // javascript implementation of the 'gl_start' virtual method
    }

called in the GL thread to setup the element GL state.

Parameters:

`src` (GstGL.GLBaseSrc) –
No description available
Returns (Number) –
No description available

#### do_gl_start

    def do_gl_start (src):
        #python implementation of the 'gl_start' virtual method

called in the GL thread to setup the element GL state.

Parameters:

`src` (GstGL.GLBaseSrc) –
No description available
Returns (bool) –
No description available

#### gl_stop

    gl_stop (GstGLBaseSrc * src)

called in the GL thread to setup the element GL state.

Parameters:

`src` –
No description available

#### vfunc_gl_stop

    function vfunc_gl_stop(src: GstGL.GLBaseSrc): {
        // javascript implementation of the 'gl_stop' virtual method
    }

called in the GL thread to setup the element GL state.

Parameters:

`src` (GstGL.GLBaseSrc) –
No description available

#### do_gl_stop

    def do_gl_stop (src):
        #python implementation of the 'gl_stop' virtual method

called in the GL thread to setup the element GL state.

Parameters:

`src` (GstGL.GLBaseSrc) –
No description available

The results of the search are